package  
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	
	/**
	 * ...
	 * @author Sascha
	 */
	public class Hero extends Sprite 
	{
		private var speed:Point = new Point();
		private var power:Number = new Number();
		private var controller:UserController;
		private var friction:Number = new Number();
		
		private var model:Shape = new Shape();
		
		
		public function Hero(_controller:UserController) 
		{
			controller = _controller;
			speed.x = 0;
			speed.y = 0;
			power = 0.5;
			friction = 0.95;
			
			drawHero();
		}
		
		private function drawHero():void 
		{
			model.graphics.beginFill(0xAA0000, 0.9);
			model.graphics.lineStyle(2);
			model.graphics.drawCircle(0, 0, 30);
			model.graphics.beginFill(0xFFFF00, 1);
			model.graphics.drawCircle(0, -30, 5);
			
			this.addChild(model);
		}
		
		public function update():void 
		{
			if (controller.isKeyDown[Keyboard.UP])
				this.speed.y -= this.power;
			if (controller.isKeyDown[Keyboard.DOWN])
				this.speed.y += this.power;
			if (controller.isKeyDown[Keyboard.LEFT])
				this.speed.x -= this.power;
			if (controller.isKeyDown[Keyboard.RIGHT])
				this.speed.x += this.power;
				
			this.speed.x *= this.friction;
			this.speed.y *= this.friction;
			
			var angle:Number = (Math.atan2(this.speed.y, this.speed.x) * 180 / Math.PI) + 90;
			this.rotation = angle;
			
				
			this.x += this.speed.x;
			this.y += this.speed.y;
			
			if (this.x -30 < 0)
			{
				this.speed.x = -this.speed.x * 0.5;
				this.x = 31;
			}
			if (this.x + 30 > Main.myStage.stageWidth)
			{
				this.speed.x = -this.speed.x * 0.5;
				this.x = Main.myStage.stageWidth - 31;
			}
			if (this.y -30 < 0)
			{
				this.speed.y = -this.speed.y * 0.5;
				this.y = 31;
			}
			if (this.y + 30 > Main.myStage.stageHeight)
			{
				this.speed.y = -this.speed.y * 0.5;
				this.y = Main.myStage.stageHeight - 31;
			}
		}
		
	}

}