package 
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.utils.Timer;
	
	/**
	 * ...
	 * @author Sascha
	 */
	public class Main extends Sprite 
	{
		private var myHero:Hero;
		private var myController:UserController;
		private var coinTimer:Timer = new Timer(3000, 0);
		private var itemContainer:Sprite = new Sprite();
		private var points:Number = new Number(0);
		private var pointsText:TextField = new TextField();
		public static var myStage:Stage;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			myStage = stage;
			
			pointsText.x = 0;
			pointsText.y = 0;
			pointsText.text = "Punkte: " + points;
			this.addChild(pointsText);
			
			this.addChild(itemContainer);
			
			myController = new UserController();
			
			myHero = new Hero(myController);
			myHero.x = stage.stageWidth * 0.5;
			myHero.y = stage.stageHeight * 0.5;
			this.addChild(myHero);
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, myController.keyboardInput);
			stage.addEventListener(KeyboardEvent.KEY_UP, myController.keyboardInput);
			
			stage.addEventListener(Event.ENTER_FRAME, gameLoop);
			
			coinTimer.addEventListener(TimerEvent.TIMER, dropCoin);
			coinTimer.start();
		}
		
		private function gameLoop(e:Event):void 
		{
			myHero.update();
			checkCollision();
		}
		
		private function dropCoin(e:Event):void 
		{
			var myCoin:Coin = new Coin();
			myCoin.x = stage.stageWidth * Math.random();
			myCoin.y = stage.stageHeight * Math.random();
			
			itemContainer.addChild(myCoin);
		}
		
		private function checkCollision():void 
		{
			for (var i:Number = itemContainer.numChildren - 1; i >= 0; i--)
			{
				if (myHero.hitTestObject(itemContainer.getChildAt(i)))
				{
					points += Coin(itemContainer.getChildAt(i)).value;
					pointsText.text = "Punkte: " + points;
					itemContainer.removeChildAt(i);
				}
			}
		}
		
	}
	
}